*描述性统计
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
tsfill
bys countycode: mipolate hospital year, epolate gen(hospital1) //补充hospital
bys countycode: mipolate invest3 year, epolate gen(invest4) //补充投资
bys countycode: mipolate realsalary year, epolate gen(realsalary1) //补充收入
bys countycode: mipolate gdp2 year, epolate gen(gdp3) //补充gdp
bys countycode: mipolate industry_num year, epolate gen(industry_num1) //补充industry
bys countycode: mipolate save year, epolate gen(save1) //补充save
bys countycode: mipolate loan year, epolate gen(loan1) //补充loan
bys countycode: mipolate exp year, epolate gen(exp1) //补充exp
bys countycode: mipolate first year, epolate gen(first1) //补充exp
bys countycode: mipolate second year, epolate gen(second1) //补充second
bys countycode: mipolate third2 year, epolate gen(third3) //补充third3

gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen exp_per=ln(exp/pop)
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen depen1=(exp-income)/gdp2
gen gdp_des=gdp2/10000
gen stru=third2/second
gen salary_fwd = F.lnsalary


logout, save(tab6, replace) word dec(4) replace: tabstat stru lnsalary saveratio gdp_des treat1 treat2 ///
treat3 popdensity indscale depen2 expratio exp_per firstratio secondratio thirdratio lnins1 lnins2 ///描述性统计
lnhospital invratio loanratio depen1, stat( mean sd min max n) /// 
 c(s)  f(%9.4f) 
 
*描述性统计34个退出县 
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total1.csv,clear
keep if poor02==1
gen lnsalary=log(realsalary)
gen gdp_des=gdp2/10000
gen expratio=exp/gdp2*100
gen depen1=(exp-income)/gdp2
logout, save(tab7, replace) word dec(4) replace: tabstat lnsalary gdp_des expratio depen1, stat( mean sd min max n) /// 
 c(s)  f(%9.4f) 


*分组-不补充数据估计
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==1 & poor02==0

gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen stu1=student_mid/(pop*100)
gen stu2=student_pri/(pop*100)
gen stu3=(student_pri+student_mid)/(pop*100)
gen depen=exp/income
gen depen1=(exp-income)/gdp2
gen depen2=(exp-income)/income
gen gap1=treat1*depen1
gen gap2=treat1*depen
gen salary_fwd = F.lnsalary

xtreg salary_fwd treat1 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
xtreg lnsalary treat1 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m4
drop if poor05==1
drop if poor06==1
xtreg salary_fwd treat2 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
xtreg lnsalary treat2 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m5

 
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==1 & poor02==0

gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen stu1=student_mid/(pop*100)
gen stu2=student_pri/(pop*100)
gen stu3=(student_pri+student_mid)/(pop*100)
gen depen=exp/income
gen depen1=(exp-income)/gdp2
gen depen2=(exp-income)/income
gen gap1=treat1*depen1
gen gap2=treat1*depen
gen salary_fwd = F.lnsalary
drop if poor04==1
drop if poor06==1
xtreg salary_fwd treat3 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
xtreg lnsalary treat3 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m6

local save "using Tab1.csv"  
local keep "treat1 treat2 treat3 expratio invratio loanratio saveratio popdensity  indscale firstratio secondratio"
esttab m1 m2 m3 m4 m5 m6  `save' , b(%6.4f) nogaps replace se ///
star(* 0.1 ** 0.05 *** 0.01) order(`keep') keep(`keep')  compress ///
scalar(r2 N)



*进一步研究部分
*产业结构
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==0
gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen struc=third2/second*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen stu1=student_mid/(pop*100)
gen stu2=student_pri/(pop*100)
gen stu3=(student_pri+student_mid)/(pop*100)
gen depen=exp/income
gen depen1=(exp-income)/gdp2
gen depen2=(exp-income)/income
gen gap1=treat1*depen1
gen gap2=treat1*depen
gen salary_fwd = F.lnsalary

*增
drop if poor05==1
drop if poor06==1
xtreg struc treat2 expratio saveratio popdensity loanratio invratio indscale i.year, fe r
est store m1
xtreg firstratio treat2 expratio saveratio popdensity loanratio invratio indscale i.year, fe r
est store m2
xtreg secondratio treat2 expratio saveratio popdensity loanratio invratio indscale i.year, fe r
est store m3
xtreg thirdratio treat2 expratio saveratio popdensity loanratio invratio indscale i.year, fe r
est store m4


clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year

drop if poor01==0
gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen struc=third2/second*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen stu1=student_mid/(pop*100)
gen stu2=student_pri/(pop*100)
gen stu3=(student_pri+student_mid)/(pop*100)
gen depen=exp/income
gen depen1=(exp-income)/gdp2
gen depen2=(exp-income)/income
gen gap1=treat1*depen1
gen gap2=treat1*depen
gen salary_fwd = F.lnsalary

*减
drop if poor04==1
drop if poor06==1
xtreg struc treat3 expratio saveratio popdensity loanratio invratio indscale i.year, fe r
est store m5
xtreg firstratio treat3 expratio saveratio popdensity loanratio invratio indscale i.year, fe r
est store m6
xtreg secondratio treat3 expratio saveratio popdensity loanratio invratio indscale i.year, fe r
est store m7
xtreg thirdratio treat3 expratio saveratio popdensity loanratio invratio indscale i.year, fe r
est store m8

local save "using Tab2.csv"  
local keep "treat2 treat3 expratio saveratio popdensity loanratio invratio indscale"
esttab m1 m2 m3 m4 m5 m6 m7 m8 `save' , b(%6.4f) nogaps replace se ///
star(* 0.1 ** 0.05 *** 0.01) order(`keep') keep(`keep')  compress ///
scalar(r2 N)

*投资
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==0
gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
xtreg invratio treat1 expratio saveratio popdensity loanratio indscale firstratio secondratio i.year, fe r
est store m1
drop if poor05==1
drop if poor06==1
xtreg invratio treat2 expratio saveratio popdensity loanratio indscale firstratio secondratio i.year, fe r
est store m2

clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==0
gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
drop if poor04==1
drop if poor06==1
xtreg invratio treat3 expratio saveratio popdensity loanratio indscale firstratio secondratio i.year, fe r
est store m3
local save "using Tab6.csv"  
local keep "treat1 treat2 treat3 expratio loanratio saveratio popdensity  indscale firstratio secondratio"
esttab m1 m2 m3 `save' , b(%6.4f) nogaps replace se ///
star(* 0.1 ** 0.05 *** 0.01) order(`keep') keep(`keep')  compress ///
scalar(r2 N)


*贷款
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==0
gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
xtreg loanratio treat1 expratio invratio saveratio popdensity indscale firstratio secondratio i.year, fe r
est store m4
drop if poor05==1
drop if poor06==1
xtreg loanratio treat2 expratio invratio saveratio popdensity indscale firstratio secondratio i.year, fe r
est store m5


clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==0
gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
drop if poor04==1
drop if poor06==1
xtreg  loanratio treat3 expratio invratio saveratio popdensity  indscale firstratio secondratio i.year, fe r
est store m6

local save "using Tab5.csv"  
local keep "treat1 treat2 treat3 expratio invratio loanratio saveratio popdensity  indscale firstratio secondratio"
esttab m1 m2 m3 m4 m5 m6 `save' , b(%6.4f) nogaps replace se ///
star(* 0.1 ** 0.05 *** 0.01) order(`keep') keep(`keep')  compress ///
scalar(r2 N)



*机制：财政压力/依赖对不同地区收入的作用
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==1 & poor02==0
gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen exp_per=ln(exp/pop)
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen stu1=student_mid/(pop*100)
gen stu2=student_pri/(pop*100)
gen stu3=(student_pri+student_mid)/(pop*100)
gen depen=exp/income
gen depen1=(exp-income)/gdp2
gen depen2=(exp-income)/income
gen quekou=income-exp
gen income_gdp=income/gdp2*100
gen gap1=treat1*depen1
gen gap2=treat1*depen2
gen salary_fwd = F.lnsalary
drop if poor05==1
drop if poor06==1
xtreg salary_fwd treat2 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m1
xtreg expratio treat2 invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m2
xtreg salary_fwd treat2 exp_per invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m3
xtreg exp_per treat2 invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m4
xtreg depen2 treat2 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m9


clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using total.csv,clear
tsset countycode year
drop if poor01==1 & poor02==0
gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen exp_per=ln(exp/pop)
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen stu1=student_mid/(pop*100)
gen stu2=student_pri/(pop*100)
gen stu3=(student_pri+student_mid)/(pop*100)
gen depen=exp/income
gen depen1=(exp-income)/gdp2
gen depen2=(exp-income)/income
gen income_gdp=income/gdp2*100
gen income_per=income/pop
gen quekou=income-exp
gen gap1=treat1*depen1
gen gap2=treat1*depen2
gen salary_fwd = F.lnsalary
drop if poor04==1
drop if poor06==1

xtreg salary_fwd treat3 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m5
xtreg expratio treat3  invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m6
xtreg salary_fwd treat3 exp_per invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m7
xtreg exp_per treat3  invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m8
xtreg depen2 treat3 expratio invratio saveratio loanratio popdensity indscale firstratio secondratio i.year, fe r
est store m10

local save "using Tab5.csv"  
local keep "treat2 treat3 expratio exp_per invratio loanratio saveratio popdensity  indscale firstratio secondratio"
esttab m1 m3 m2 m4 m9 m5 m7 m6 m8 m10 `save' , b(%6.4f) nogaps replace se ///
star(* 0.1 ** 0.05 *** 0.01) order(`keep') keep(`keep')  compress ///
scalar(r2 N)
   

   
*安慰剂（全部安慰剂结果未在正文体现，具体内容见附件）
*减
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using placebo1.csv,clear
tsset countycode year
drop if poor01==1 & poor02==0

gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen exp_per=ln(exp/pop)
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen stu1=student_mid/(pop*100)
gen stu2=student_pri/(pop*100)
gen stu3=(student_pri+student_mid)/(pop*100)
gen depen=exp/income
gen depen1=(exp-income)/gdp2
gen depen2=(exp-income)/income
gen income_gdp=income/gdp2*100
gen income_per=income/pop
gen quekou=income-exp
gen gap1=treat1*depen1
gen gap2=treat1*depen2
gen salary_fwd = F.lnsalary
drop if poor04==1
drop if poor06==1
save poor1, replace



forvalue i=1/500{
    use poor1
    *- 思路：打乱poor,即将poor的全部取值拿出暂存，然后随机赋给每一个样本

    *- 打乱poor,即将poor的全部取值拿出暂存
    g obs_id= _n //初始样本序号
    gen random_digit= runiform() //生成随机数
    sort random_digit  //按新生成的随机数排序
    g random_id= _n  //产生随机序号
    preserve
        keep random_id treat3 //保留虚拟的poor
        rename treat3 random_poor
        rename random_id id //重命名为id，以备与其他变量合并（merge）
        label var id //原数据与虚拟处理变量的唯一匹配码
        save random_poor, replace
    restore 
        drop random_digit random_id treat3 //删除原来的poor
        rename obs_id id //重命名为id，以备与random_poor合并（merge）
        label var id //原数据与虚拟处理变量的唯一匹配码
        save rawdata, replace 

    *- 合并，回归，提取系数
        use rawdata, clear
        merge 1:1 id using random_poor,nogen
        xtreg salary_fwd random_poor ///
		      expratio invratio saveratio loanratio popdensity indscale firstratio secondratio
        g _b_random_poor= _b[random_poor]  //提取x的回归系数
        g _se_random_poor= _se[random_poor] //提取x的标准误
        keep _b_random_poor _se_random_poor 
        duplicates drop _b_random_poor, force
        save placebo`i', replace  //把第i次placebo检验的系数和标准误存起来
    }
    
*- 纵向合并500次的系数和标准误 
use placebo1, clear
forvalue i=2/500{
    append using placebo`i' //纵向合并500次回归的系数及标准误
}  
 
gen tvalue= _b_random_poor/ _se_random_poor
kdensity _b_random_poor,xtitle("政策效应评估", size(middle)) ///
ytitle("频数分布",size(middle)) saving(placebo_test) ///
scheme(s1color) ///
xline(-0.0789) ///
xlabel(-0.1(0.05)0.1) ///
ylabel(0(4)16)
graph export placebo1.tif


*增
clear
cd D:\Stata14\ado\personal\data2\psm_did
insheet using placebo1.csv,clear
tsset countycode year
drop if poor01==1 & poor02==0

gen lnsalary=log(realsalary)
gen saveratio=save/gdp2*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp2*100
gen exp_per=ln(exp/pop)
gen firstratio=first/gdp2*100
gen secondratio=second/gdp2*100
gen thirdratio=third2/gdp2*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest3/gdp2*100
gen loanratio=loan/gdp2*100
gen stu1=student_mid/(pop*100)
gen stu2=student_pri/(pop*100)
gen stu3=(student_pri+student_mid)/(pop*100)
gen depen=exp/income
gen depen1=(exp-income)/gdp2
gen depen2=(exp-income)/income
gen income_gdp=income/gdp2*100
gen income_per=income/pop
gen quekou=income-exp
gen gap1=treat1*depen1
gen gap2=treat1*depen2
gen salary_fwd = F.lnsalary
drop if poor05==1
drop if poor06==1
save poor2, replace



forvalue i=1/500{
    use poor2
    *- 思路：打乱poor,即将poor的全部取值拿出暂存，然后随机赋给每一个样本

    *- 打乱poor,即将poor的全部取值拿出暂存
    g obs_id= _n //初始样本序号
    gen random_digit= runiform() //生成随机数
    sort random_digit  //按新生成的随机数排序
    g random_id= _n  //产生随机序号
    preserve
        keep random_id treat2 //保留虚拟的poor
        rename treat2 random_poor
        rename random_id id //重命名为id，以备与其他变量合并（merge）
        label var id //原数据与虚拟处理变量的唯一匹配码
        save random_poor, replace
    restore 
        drop random_digit random_id treat2 //删除原来的poor
        rename obs_id id //重命名为id，以备与random_poor合并（merge）
        label var id //原数据与虚拟处理变量的唯一匹配码
        save rawdata, replace 

    *- 合并，回归，提取系数
        use rawdata, clear
        merge 1:1 id using random_poor,nogen
        xtreg salary_fwd random_poor ///
		      expratio invratio saveratio loanratio popdensity indscale firstratio secondratio
        g _b_random_poor= _b[random_poor]  //提取x的回归系数
        g _se_random_poor= _se[random_poor] //提取x的标准误
        keep _b_random_poor _se_random_poor 
        duplicates drop _b_random_poor, force
        save placebo`i', replace  //把第i次placebo检验的系数和标准误存起来
    }
    
*- 纵向合并500次的系数和标准误 
use placebo1, clear
forvalue i=2/500{
    append using placebo`i' //纵向合并500次回归的系数及标准误
}  
 
gen tvalue= _b_random_poor/ _se_random_poor
kdensity _b_random_poor,xtitle("政策效应评估", size(middle)) ///
ytitle("频数分布",size(middle)) saving(placebo_test) ///
scheme(s1color) ///
xline(0.0848) ///
xlabel(-0.1(0.05)0.1) ///
ylabel(0(4)16)
graph export placebo2.tif




