*河北*
*填补投资、消费、收入、GDP
clear 
cd D:\Stata14\ado\personal\data2\scm\time_cheat\hb
set matsize 5000
insheet using hebei_7.csv
tsset countycode year

tsfill
bys countycode: mipolate invest3 year, epolate gen(invest4) //补充投资
bys countycode: mipolate realsalary year, epolate gen(realsalary1) //补充收入
bys countycode: mipolate gdp2 year, epolate gen(gdp3) //补充收入
bys countycode: mipolate loan year, epolate gen(loan1) //补充loan
bys countycode: mipolate third2 year, epolate gen(third3) //补充exp
bys countycode: mipolate save year, epolate gen(save1) //补充save


gen lnsalary=log(realsalary1)
gen saveratio=save1/gdp3*100
gen popdensity=pop/land*100  //人口密度：百人每平方公里
gen indscale=log(industry_num)
gen expratio=exp/gdp3*100
gen firstratio=first/gdp3*100
gen secondratio=second/gdp3*100
gen thirdratio=third3/gdp3*100
gen indstrut=third3/second*100
gen lnins1=log(instance1)
gen lnins2=log(instance2)
gen lnhospital=log(hospital)
gen invratio=invest4/gdp3*100
gen lnmech=log(mech)
gen lnloan=log(loan1)
gen loanratio=loan1/gdp3*100


*合成控制法合成每个目标县，以河北各县为例。
*稳健性检验中剔除相似县的代码相同
*预测变量：人口密度，产业规模，财政支出，二产占比，三产占比，距省会距离，距市中心距离，床位数，储蓄，贷款固定资产投资
drop if poor03==1 | countycode==130432 | countycode==130827 | countycode==130923 ///涉县
  | countycode==130929 | countycode==130925
synth lnsalary lnsalary(2006(1)2012) popdensity indscale expratio secondratio ///
  thirdratio lnins1 lnins2 lnhospital saveratio loanratio invratio lnsalary(2006) ///
  lnsalary(2008) lnsalary(2010), trunit(130426) trperiod(2012) nested keep(synth_sx,replace)
use synth_sx,clear  //估计的数值，包含各县的权重

drop if poor03==1 | countycode==130426 | countycode==130827 | countycode==130923 ///广平
  | countycode==130929 | countycode==130930 | countycode==130431
synth lnsalary lnsalary(2006(1)2012) popdensity indscale expratio secondratio ///
  thirdratio lnins1 lnins2 lnhospital saveratio loanratio invratio lnsalary(2006) ///
  lnsalary(2008) lnsalary(2010), trunit(130432) trperiod(2012) nested keep(synth_gp,replace)
use synth_gp,clear


drop if poor03==1 | countycode==130426 | countycode==130432 | countycode==130923 ///宽城
  | countycode==130929 | countycode==130930
synth lnsalary lnsalary(2006(1)2014) popdensity indscale expratio secondratio ///
  thirdratio lnins1 lnins2 lnhospital saveratio loanratio invratio lnsalary(2006) ///
  lnsalary(2010) lnsalary(2014), trunit(130827) trperiod(2014) nested keep(synth_kc,replace)
use synth_kc,clear

drop if poor03==1 | countycode==130426 | countycode==130432 | countycode==130827 ///东光
  | countycode==130929 | countycode==130930  | countycode==130926
synth lnsalary lnsalary(2006(1)2014) popdensity indscale expratio secondratio ///
  thirdratio lnins1 lnins2 lnhospital saveratio loanratio invratio lnsalary(2006) ///
  lnsalary(2007) lnsalary(2008), trunit(130923) trperiod(2009) nested keep(synth_dg,replace)
use synth_dg,clear

drop if poor03==1 | countycode==130426 | countycode==130432 | countycode==130827 ///献县
  | countycode== 130923 | countycode==130930 | countycode==130321
synth lnsalary lnsalary(2006(1)2012) popdensity indscale expratio secondratio ///
  thirdratio lnins1 lnins2 lnhospital saveratio loanratio invratio lnsalary(2006) ///
  lnsalary(2008) lnsalary(2010), trunit(130929) trperiod(2012) nested keep(synth_xx,replace)
use synth_xx,clear

drop if poor03==1 | countycode==130426 | countycode==130432 | countycode==130827 ///孟村
  | countycode== 130923 | countycode==130929
synth lnsalary lnsalary(2006(1)2014) popdensity indscale expratio secondratio ///
  thirdratio lnins1 lnins2 lnhospital saveratio loanratio invratio lnsalary(2006) ///
  lnsalary(2010) lnsalary(2014), trunit(130930) trperiod(2014) nested keep(synth_mc,replace)
use synth_mc,clear

*以河北东光为例进行排列序检验，其余县均相同（全部排列序结果未在正文体现，具体内容见附件）
clear 
cd D:\Stata14\ado\personal\data2\scm\hb
set matsize 5000
use synth_dg, clear

rename _time years
gen tr_effect_128 = _Y_treated - _Y_synthetic
keep years tr_effect_128
drop if missing(years)
save synth_128, replace

use synth_1, clear
forval i=2/128{
qui merge 1:1 years using synth_`i', nogenerate
}

local lp1
forval i=1/23 {
   local lp1 `lp1' line tr_effect_`i' years, lpattern(dash) lcolor(gs8) ||
}

local lp2
forval i=25/26 {
   local lp2 `lp2' line tr_effect_`i' years, lpattern(dash) lcolor(gs8) ||
}
 
local lp3
forval i=28/65 {
   local lp3 `lp3' line tr_effect_`i' years, lpattern(dash) lcolor(gs8) ||
}
 
local lp4
forval i=67/69 {
   local lp4 `lp4' line tr_effect_`i' years, lpattern(dash) lcolor(gs8) ||
}

local lp5
forval i=71/71 {
   local lp5 `lp5' line tr_effect_`i' years, lpattern(dash) lcolor(gs8) ||
}

local lp6
forval i=73/81 {
   local lp6 `lp6' line tr_effect_`i' years, lpattern(dash) lcolor(gs8) ||
}

local lp7
forval i=85/124 {
   local lp7 `lp7' line tr_effect_`i' years, lpattern(dash) lcolor(gs8) ||
}

local lp8
forval i=128/128 {
   local lp8 `lp8' line tr_effect_`i' years, lpattern(dash) lcolor(gs8) ||
}
**create plot
twoway `lp1' `lp2' `lp3' `lp4' `lp5' `lp6' `lp7' `lp8' || line tr_effect_128 years, ///
    lcolor(black) legend(off) /// 
	scheme(s1color) ///
	xline(2012, lpattern(dash))  ///
    xlabel(2006(1)2019,angle(horizontal)) ///
    yline(0, lpattern(dash)) ///
	xtitle("",  axis(1))
graph export testing_dg.tif,replace	



